;Memmax 1.0 by Falcosoft

.586p
MMAX SEGMENT PUBLIC USE16
assume cs:MMAX,ds:MMAX,ss:MMAX
org 100h
START:

	    mov ax,offset prog
            call show
            mov ax,offset eol
            call show

	    mov ax,0F000h ;386+ detect
	    push ax
	    popf
	    pushf
	    pop ax
	    and ah,0F0h
	    sti
	    jz @nosupport

            pushfd       ;cpuid detect
            pop eax
            mov ebx,eax
            btc eax,21
            push eax
            popfd
            pushfd
            pop eax
            cmp eax,ebx
            jz @nosupport

	    mov eax,80000000h ;required extended function detect
            cpuid
            cmp eax,80000007h
            jb @nosupport

	    mov eax,80000007h ;FID,VID detect
            cpuid
            test edx,06h
            jz @nosupport
            mov ax,offset before
            call show

            mov eax,8000C294h
            mov dx,0cf8h
            out  dx,eax

            mov dx,0cfch
            xor eax,eax
            in al,dx
            call PrintNumber
            mov ax,offset eol
            call show

            mov si,82h   ;get command line parameter

	    mov bl,"0"
            cmp bl,[si]
            jnz @nonull
            mov eax,8000C294h
            mov dx,0cf8h
            out  dx,eax

            mov dx,0cfch
            xor eax,eax
            mov al,06Ah
            out dx,al

	    jmp @ready
@nonull:
            mov eax,8000C294h
            mov dx,0cf8h
            out  dx,eax

            mov dx,0cfch
            xor eax,eax
            mov al,06Bh
            out dx,al


@ready:
            mov ax,offset after
            call show

            mov eax,8000C294h
            mov dx,0cf8h
            out  dx,eax

            mov dx,0cfch
            xor eax,eax
            in al,dx
            call PrintNumber
            mov ax,offset eol
            call show
	    jmp @exitp

@nosupport:
	    mov ax,offset nosup
            call show

@exitp:     xor eax,eax
            mov ax,4c00h
            INT 21h

	    show proc
             mov dx,ax
             mov ah,9
             int 21h
             ret
            show endp

            PrintNumber proc
    	     mov ecx, 0
    	     mov ebx, 10
	     @@loophere:
    	     mov edx, 0
    	     div ebx             ;divide by ten

                                 ; now eax <-- eax/10
                                 ;     edx <-- eax % 10

                                 ; this is one digit we have to convert to ASCII
  	     push eax
    	     add dl, '0'         ;convert dl to ascii

	     pop eax
    	     push edx            ;digits are in reversed order
    	     inc ecx             ;remember how many digits we pushed to stack
    	     cmp eax, 0
	     jnz @@loophere

	    ;ecx is already set
    	    mov ah, 2
	    @@loophere2:
    	    pop edx              ;restore digits from last to first
    	    int 21h
    	    loop @@loophere2

	    ret
           PrintNumber endp


prog       db "MEMMAX for Nx6325 by Falcosoft","$"
before     db "before: ","$"
after      db "after: ","$"
nosup  	   db "CPU not supported!","$"
eol        db 10,13,"$"


MMAX ENDS
END START